# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .agent_type import AgentType
from .llm_model import LlmModel


class PrismaModelsAgent(pydantic_v1.BaseModel):
    """
    Represents a Agent record
    """

    id: str
    type: AgentType
    name: str
    avatar: typing.Optional[str]
    initial_message: typing.Optional[str] = pydantic_v1.Field(alias="initialMessage")
    description: str
    is_active: bool = pydantic_v1.Field(alias="isActive")
    created_at: dt.datetime = pydantic_v1.Field(alias="createdAt")
    updated_at: dt.datetime = pydantic_v1.Field(alias="updatedAt")
    llms: typing.Optional[typing.List[PrismaModelsAgentLlm]]
    llm_model: typing.Optional[LlmModel] = pydantic_v1.Field(alias="llmModel")
    prompt: typing.Optional[str]
    api_user_id: str = pydantic_v1.Field(alias="apiUserId")
    api_user: typing.Optional[PrismaModelsApiUser] = pydantic_v1.Field(alias="apiUser")
    datasources: typing.Optional[typing.List[PrismaModelsAgentDatasource]]
    tools: typing.Optional[typing.List[PrismaModelsAgentTool]]
    workflow_steps: typing.Optional[typing.List[PrismaModelsWorkflowStep]] = pydantic_v1.Field(alias="workflowSteps")
    metadata: typing.Optional[typing.Any]
    output_schema: typing.Optional[str] = pydantic_v1.Field(alias="outputSchema")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.forbid
        json_encoders = {dt.datetime: serialize_datetime}


from .prisma_models_agent_datasource import PrismaModelsAgentDatasource  # noqa: E402
from .prisma_models_agent_llm import PrismaModelsAgentLlm  # noqa: E402
from .prisma_models_agent_tool import PrismaModelsAgentTool  # noqa: E402
from .prisma_models_api_user import PrismaModelsApiUser  # noqa: E402
from .prisma_models_workflow_step import PrismaModelsWorkflowStep  # noqa: E402

PrismaModelsAgent.update_forward_refs()
