# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1


class PrismaModelsApiUser(pydantic_v1.BaseModel):
    """
    Represents a ApiUser record
    """

    id: str
    token: typing.Optional[str]
    email: typing.Optional[str]
    created_at: dt.datetime = pydantic_v1.Field(alias="createdAt")
    updated_at: dt.datetime = pydantic_v1.Field(alias="updatedAt")
    agents: typing.Optional[typing.List[PrismaModelsAgent]]
    llms: typing.Optional[typing.List[PrismaModelsLlm]]
    datasources: typing.Optional[typing.List[PrismaModelsDatasource]]
    tools: typing.Optional[typing.List[PrismaModelsTool]]
    workflows: typing.Optional[typing.List[PrismaModelsWorkflow]]
    vector_db: typing.Optional[typing.List[PrismaModelsVectorDb]] = pydantic_v1.Field(alias="vectorDb")
    workflow_configs: typing.Optional[typing.List[WorkflowConfig]] = pydantic_v1.Field(alias="workflowConfigs")
    api_keys: typing.Optional[typing.List[PrismaModelsApiKey]] = pydantic_v1.Field(alias="apiKeys")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.forbid
        json_encoders = {dt.datetime: serialize_datetime}


from .prisma_models_agent import PrismaModelsAgent  # noqa: E402
from .prisma_models_api_key import PrismaModelsApiKey  # noqa: E402
from .prisma_models_datasource import PrismaModelsDatasource  # noqa: E402
from .prisma_models_llm import PrismaModelsLlm  # noqa: E402
from .prisma_models_tool import PrismaModelsTool  # noqa: E402
from .prisma_models_vector_db import PrismaModelsVectorDb  # noqa: E402
from .prisma_models_workflow import PrismaModelsWorkflow  # noqa: E402
from .workflow_config import WorkflowConfig  # noqa: E402

PrismaModelsApiUser.update_forward_refs()
